993c2131e1f8bbf6ff178955abb974b308e564ff
[oweals/gnunet.git] / src / gns / test_gns_rel_expiration.sh
1 #!/bin/sh
2 # This file is in the public domain.
3 trap "gnunet-arm -e -c test_gns_lookup.conf" SIGINT
4
5 LOCATION=$(which gnunet-config)
6 if [ -z $LOCATION ]
7 then
8   LOCATION="gnunet-config"
9 fi
10
11 if [ -z $(which timeout) ]
12 then
13   echo "timeout utility not found which is required for test."
14   exit 77
15 fi
16
17 $LOCATION --version 1> /dev/null
18 if test $? != 0
19 then
20         echo "GNUnet command line tools cannot be found, check environmental variables PATH and GNUNET_PREFIX"
21         exit 77
22 fi
23
24 MY_EGO="myego"
25 OTHER_EGO="delegatedego"
26
27 rm -rf `gnunet-config -c test_gns_lookup.conf -f -s paths -o GNUNET_TEST_HOME`
28 which timeout > /dev/null 2>&1 && DO_TIMEOUT="timeout 5"
29 TEST_IP="127.0.0.1"
30 gnunet-arm -s -c test_gns_lookup.conf
31 gnunet-identity -C $MY_EGO -c test_gns_lookup.conf
32 gnunet-identity -C $OTHER_EGO -c test_gns_lookup.conf
33 DELEGATED_PKEY=$(gnunet-identity -d -c test_gns_lookup.conf | grep $OTHER_EGO | awk '{print $3}')
34 gnunet-namestore -p -z $MY_EGO -a -n b -t PKEY -V $DELEGATED_PKEY -e never -c test_gns_lookup.conf
35 gnunet-namestore -p -z $OTHER_EGO -a -n www -t A -V $TEST_IP -e '5 s' -c test_gns_lookup.conf
36 gnunet-arm -i gns -c test_gns_lookup.conf
37 # confirm that lookup currently works
38 RES_IP=`$DO_TIMEOUT gnunet-gns --raw -u www.b.$MY_EGO -t A -c test_gns_lookup.conf`
39 # remove entry
40 gnunet-namestore -z $OTHER_EGO -d -n www -t A -V $TEST_IP  -e '5 s' -c test_gns_lookup.conf
41 # wait for old entry with 5s 'expiration' to definitively expire
42 sleep 6
43 # try again, should no longer work
44 RES_IP_EXP=`$DO_TIMEOUT gnunet-gns --raw -u www.b.$MY_EGO -t A -c test_gns_lookup.conf`
45 gnunet-namestore -z $MY_EGO -d -n b -t PKEY -V $DELEGATED_PKEY  -e never -c test_gns_lookup.conf
46 gnunet-identity -D $MY_EGO -c test_gns_lookup.conf
47 gnunet-identity -D $OTHER_EGO -c test_gns_lookup.conf
48 gnunet-arm -e -c test_gns_lookup.conf
49 rm -rf `gnunet-config -c test_gns_lookup.conf -f -s paths -o GNUNET_TEST_HOME`
50
51 if [ "$RES_IP_EXP" = "$TEST_IP" ]
52 then
53   echo "Failed to properly expire IP, got $RES_IP_EXP."
54   exit 1
55 fi
56
57 if [ "$RES_IP" = "$TEST_IP" ]
58 then
59   exit 0
60 else
61   echo "Failed to properly resolve IP, got $RES_IP."
62   exit 1
63 fi